/*
 *  libmenuthing v0.0.1 demo
 *  demonstrates the use of current functions
 *  ARM (GP2X)
 */

/* include libmenuthing header, found in lmt/ */
#include <lmt/libmenuthing.h>

using namespace std;

/* exit function */
void test(void *arg)
{
    printf("Exiting!\n", arg);
    exit((int) arg);
}

int main()
{
    SDL_Surface *screen;
    
    printf("init video\n");
    /* init video and joystick */
    if (SDL_Init(SDL_INIT_VIDEO|SDL_INIT_JOYSTICK) != 0) {
        printf("Unable to initialize SDL: %s\n", SDL_GetError());
        return 1;
    }
    
    atexit(SDL_Quit);
    
    /* set video mode */
    screen = SDL_SetVideoMode(320, 240, 16, SDL_SWSURFACE);
    if (screen == NULL) {
        printf("Unable to set video mode: %s\n", SDL_GetError());
        return 1;
    }
    
    /* enable joybutton action catching */
    SDL_JoystickOpen(0);
    
    /* hide the cursor */
    SDL_ShowCursor(0);
    
    /* init libmenuthing, which calls TTF_Init() if not already called */
    mt_init();
    
    /* lmt uses lists - every menu is defined like this */
    list<mt_list> listthing;
    
    /* add 4 items, all with no action except the last */
    mt_add_item(&listthing, "Item 1", NULL, NULL);
    mt_add_item(&listthing, "WWWWWWWWWWWWWWWWWWWWWW", NULL, NULL);
    mt_add_item(&listthing, "libmenuthingy v0.0.1", NULL, NULL);
    /* last item, which calls test() */
    mt_add_item(&listthing, "Exit Menu", test, (void *)1);
    
    /* start menu loop - will end on selection of an active item */
    mt_start_menu(listthing, "Menu Title", "font.ttf", "bold.ttf", screen);
    
    return 0;
}
